VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit 'v1.0.10

'Types
    Private Type tSettings
        Name As String
        Value As String
    End Type
    
'Vars
    Public FileName As String

    Dim SettingsCount As Long
    Dim Settings() As tSettings
Function GetValue(iName As String, Optional iDefault As String = "") As String
    Dim A As Long
    Dim Temp As Long

    'Go through array and find value name
    For A = 0 To SettingsCount
        If Settings(A).Name = iName Then
            'Name found so return value
            GetValue = Settings(A).Value
            
            Exit Function
        End If
    Next
    
    GetValue = iDefault
End Function
Function Load(Optional iFileName As String = "") As Long
On Error GoTo 1
    Dim A  As Long
    
    Dim Temp As Long
    Dim FileNumber As Long
    
    If Not iFileName = "" Then: FileName = iFileName
    
    Reset
    
    If Dir(FileName) = "" Then
        'Error: File doesn't exist
        Load = 0
        
        Exit Function
    End If

    'Load settings
    FileNumber = FreeFile
    Open FileName For Binary As #FileNumber
        Get FileNumber, , Temp
        SettingsCount = Temp
        ReDim Settings(SettingsCount + 1)
        
        For A = 0 To SettingsCount
            Get FileNumber, , Settings(A)
        Next
    Close #FileNumber
    
    Load = 1
    Exit Function
    
1  'Error
    Close FileNumber
End Function
Sub GetObjectPos(iObject As Object, Optional iGetSize As Boolean = False)
On Error Resume Next

    Dim Temp As String
    
    Temp = iObject.Name & iObject.Index
    If Err <> 0 Then: Temp = iObject.Name: Err.Clear

    iObject.Left = GetValue(Temp & ".x", iObject.Left)
    iObject.Top = GetValue(Temp & ".y", iObject.Top)
    
    If iGetSize Then
        iObject.Width = GetValue(Temp & ".w", iObject.Width)
        iObject.Height = GetValue(Temp & ".h", iObject.Height)
    End If
End Sub

Sub Reset()
    'Release memory
    SettingsCount = -1
    ReDim Settings(0)
End Sub
Sub SetObjectPos(iObject As Object, Optional iSetSize As Boolean = False)
On Error Resume Next

    Dim Temp As String

    Temp = iObject.Name & iObject.Index
    If Err <> 0 Then: Temp = iObject.Name: Err.Clear
    
    Call SetValue(Temp & ".x", iObject.Left)
    Call SetValue(Temp & ".y", iObject.Top)
    
    If iSetSize Then
        Call SetValue(Temp & ".w", iObject.Width)
        Call SetValue(Temp & ".h", iObject.Height)
    End If
End Sub
Sub LoadLanguage(iWindow As Form)
On Error Resume Next

    Dim Temp As Object
    
    For Each Temp In iWindow.Controls
        'Try to set caption
        Temp.Caption = GetValue(Temp.Name, Temp.Caption)
        If Not (Temp.Caption = "-" Or Temp.Caption = "") Then: SetValue Temp.Name, Temp.Caption
        
        'Clear error
        If Err.Number <> 0 Then: Err.Clear
    Next
    
    iWindow.Caption = GetValue(iWindow.Name, iWindow.Caption)
    SetValue iWindow.Name, iWindow.Caption
End Sub

Sub SaveLanguage(iWindow As Form)
On Error Resume Next

    Dim Temp As Object
    
    For Each Temp In iWindow.Controls
        'Try to set caption
        If Not (Temp.Caption = "-" Or Temp.Caption = "") Then: SetValue Temp.Name, Temp.Caption
        
        'Clear error
        If Err.Number <> 0 Then: Err.Clear
    Next
    
    SetValue iWindow.Name, iWindow.Caption
End Sub

Sub PrintNamesToList(iList As ListBox)
    Dim A As Long
    
    For A = 0 To SettingsCount
        iList.AddItem Settings(A).Name
    Next
End Sub

Function Save() As Long
On Error GoTo 1

    Dim A As Long
    Dim FileNumber As Integer
    
    If Not Dir(FileName) = "" Then: Call Kill(FileName)

    If SettingsCount > -1 Then
        'Save settings
        FileNumber = FreeFile
        Open FileName For Binary As #FileNumber
            Put FileNumber, , SettingsCount
            For A = 0 To SettingsCount
                Put FileNumber, , Settings(A)
            Next
        Close FileNumber
    End If
    
    Save = 1
    Exit Function
    
1  'Error
    Close FileNumber
End Function
Sub SetValue(iName As String, iValue As String)
    Dim A As Long

    'Go through array and find value name
    For A = 0 To SettingsCount
        If Settings(A).Name = iName Then
            'Name found so update value
            
            If iValue = "" Then
                'Delete settings
                Settings(A) = Settings(SettingsCount)
                
                SettingsCount = SettingsCount - 1
                If SettingsCount > -1 Then
                    ReDim Preserve Settings(SettingsCount)
                End If
                
            Else
                'Set value
                Settings(A).Value = iValue
            End If
            
            Exit Sub
        End If
    Next
    
    'Not found so create new settings
    SettingsCount = SettingsCount + 1
    ReDim Preserve Settings(SettingsCount)
    
    Settings(SettingsCount).Name = iName
    Settings(SettingsCount).Value = iValue
End Sub

Private Sub Class_Initialize()
    SettingsCount = -1
    ReDim Settings(0)
End Sub


Private Sub Class_Terminate()
    SettingsCount = -1
    ReDim Settings(0)
End Sub


