Attribute VB_Name = "mBitmap"
Option Explicit

'Types
    Type tRect
        'Coordinates
        x As Long
        y As Long
        
        X2 As Long
        Y2 As Long
    End Type
    
    Type tBitmap
        'System
        FileName As String
        DC As Long
        Mask As Long
        
        'Size
        W As Long
        H As Long
    End Type
    
'Declares
    Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
    Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long

    Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
    
    Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
    Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
    
    Public Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As tRect, ByVal hBrush As Long) As Long
    
    Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
    Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

'Variables
    Global BitmapCount As Long
    Global Bitmap() As tBitmap
Function LoadDC(iFilename As String, iBitmap As tBitmap) As Long
    Dim DC As Long
    Dim Temp As IPictureDisp
    
    'Create compatible DC
    DC = CreateCompatibleDC(frmMain.hdc)
    
    If DC < 1 Then
        'Error: Can't create compatible DC
        LoadDC = 0
        
        Exit Function
    End If
    
    'Load bitmap
    Set Temp = LoadPicture(iFilename)
    SelectObject DC, Temp
    
    'Apply values
    iBitmap.DC = DC
    iBitmap.W = frmMain.ScaleX(Temp.Width)
    iBitmap.H = frmMain.ScaleY(Temp.Height)
    iBitmap.FileName = LCase(iFilename)
    
    'Release memory
    DeleteObject Temp
    Set Temp = Nothing
End Function

Function CreateDC(iW As Long, iH As Long) As Long
    Dim Temp As Long
    Dim Rect As tRect
    
    'Create
    CreateDC = CreateCompatibleDC(frmMain.hdc)
    Temp = CreateCompatibleBitmap(frmMain.hdc, iW, iH)
    
    'Get the DC
    SelectObject CreateDC, Temp
    DeleteObject Temp

    'Clear
    Rect.X2 = iW
    Rect.Y2 = iH
    
    FillRect CreateDC, Rect, 0
End Function
Function LoadBitmap(iFilename As String, Optional iMasked As Boolean = False) As Long
    LoadBitmap = LoadTexture(iFilename)
    Exit Function
    
    Dim A As Long
    
    Dim x As Long
    Dim y As Long
    
    If Dir(iFilename) = "" Then
        'Error: File not found
        LoadBitmap = 0
        
        Exit Function
    End If
    
    'Check if already loaded
    For A = 0 To BitmapCount
        If Bitmap(A).FileName = LCase(iFilename) Then
            'Bitmap already loaded
            LoadBitmap = A
            
            Exit Function
        End If
    Next
    
    'Resize memory
    BitmapCount = BitmapCount + 1
    ReDim Preserve Bitmap(BitmapCount)
    
    LoadDC iFilename, Bitmap(BitmapCount)
    
    If iMasked Then
        'Create mask
        With Bitmap(BitmapCount)
            .Mask = CreateDC(.W, .H)
            
            'Generate mask
            For y = 0 To .H
                For x = 0 To .W
                    SetPixel .Mask, x, y, IIf(GetPixel(.DC, x, y) = 16777215, 0, 16777215)
                Next
            Next
        End With
    End If
    
    'Return index
    If Bitmap(BitmapCount).DC > 0 Then: LoadBitmap = BitmapCount
End Function
Sub Reset()
    Dim A As Long
    
    'Release DCs
    For A = 0 To BitmapCount
        DeleteDC Bitmap(A).DC
        DeleteDC Bitmap(A).Mask
        
        Bitmap(A).DC = 0
        Bitmap(A).Mask = 0
    Next
    
    'Release memory
    BitmapCount = 0
    ReDim Bitmap(0)
    
    Mouse.Bitmap = LoadBitmap(GraphicPath & "Mouse.bmp", True)
End Sub
Sub ShutDown()
    Reset
End Sub

