Attribute VB_Name = "mLevel"
Option Explicit
    
'Types
    Type tLevel
        Name As String
        
        W As Long
        H As Long
        
        BackSpeed As Single
        SkySpeed As Single
        
        Floor() As Integer
        Back() As Integer
        Sky() As Integer
        Object() As Integer
    End Type

'Variables
    Global Level As tLevel
Sub CreateLevel(iWidth As Long, iHeight As Long)
    'Clear memory
    Reset
    
    With Level
        'Apply size
        .W = iWidth
        .H = iHeight
        
        'Resize memory
        ReDim .Sky(.W * .H)
        ReDim .Back(.W * .H)
        ReDim .Floor(.W * .H)
        ReDim .Object(.W * .H)
    End With
End Sub
Sub Draw()
    Dim A As Long
    Dim b As Long
    
    Dim Index As Long
    Dim Temp As Long
    
    Dim TempX As Single
    Dim TempY As Single
    
    Dim Obj As Long
    
    With Level
        If DrawSky Then
            'Draw sky tiles
            'Get index position
            If .SkySpeed = 0 Then
                TempX = 0
                TempY = 0
            Else
                TempX = (Camera.x / TileW) / .SkySpeed
                TempY = (Camera.y / TileH) / .SkySpeed
            End If
            
            'Draw floor tiles
            Index = Int(TempY) * .W + Int(TempX)
            
            'Get scrolling value
            TempX = TempX - Int(TempX)
            TempY = TempY - Int(TempY)
    
            'Draw solid
            Device.SetRenderState D3DRS_SRCBLEND, D3DBLEND_ONE
            Device.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ZERO
            
            'Disable masking
            Device.SetRenderState D3DRS_ALPHATESTENABLE, 0
            
            'Draw tiles
            For b = 0 To Camera.TilesY
                For A = 0 To Camera.TilesX
                    'Back layer
                    Temp = .Sky(Index)
                    'BitBlt Camera.BackDC, (A - TempX) * TileW, (b - TempY) * TileH, TileW, TileH, Bitmap(Tile(Temp).Bitmap).DC, Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW), Tile(Temp).y, vbSrcCopy
                    BltToBuffer Tile(Temp).Bitmap, CSng((A - TempX) * TileW), CSng((b - TempY) * TileH), CSng(TileW), CSng(TileH), CSng(Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW)), CSng(Tile(Temp).y), CSng(TileW), CSng(TileH), D3DColorRGBA(255, 255, 255, 255), 0
                    
                    Index = Index + 1
                Next
                
                Index = Index + .W - Camera.TilesX - 1
            Next
        End If
        
        'Enable masking
        Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
        
        If DrawBack Then
            'Draw background tiles
            'Get index position
            TempX = (Camera.x / TileW) / .BackSpeed
            TempY = (Camera.y / TileH) / .BackSpeed
            
            'Draw floor tiles
            Index = Int(TempY) * .W + Int(TempX)
            
            'Get scrolling value
            TempX = TempX - Int(TempX)
            TempY = TempY - Int(TempY)
            
            'Draw tiles
            For b = 0 To Camera.TilesY
                For A = 0 To Camera.TilesX
                    'Back layer
                    Temp = .Back(Index)
                    If Temp > 0 Then
                        'BitBlt Camera.BackDC, (A - TempX) * TileW, (b - TempY) * TileH, TileW, TileH, Bitmap(Tile(Temp).Bitmap).Mask, Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW), Tile(Temp).y, vbSrcPaint
                        'BitBlt Camera.BackDC, (A - TempX) * TileW, (b - TempY) * TileH, TileW, TileH, Bitmap(Tile(Temp).Bitmap).DC, Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW), Tile(Temp).y, vbSrcAnd
                        BltToBuffer Tile(Temp).Bitmap, CSng((A - TempX) * TileW), CSng((b - TempY) * TileH), CSng(TileW), CSng(TileH), CSng(Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW)), CSng(Tile(Temp).y), CSng(TileW), CSng(TileH), D3DColorRGBA(255, 255, 255, 255), 0
                    End If
                    
                    Index = Index + 1
                Next
                
                Index = Index + .W - Camera.TilesX - 1
            Next
        End If
        
        mObjects.Draw
        
        If DrawFloor Then
            'Draw floor tiles
            'Get index position
            TempX = Camera.x / TileW
            TempY = Camera.y / TileH
            
            'Draw floor tiles
            Index = Int(TempY) * .W + Int(TempX)
            
            'Get scrolling value
            TempX = TempX - Int(TempX)
            TempY = TempY - Int(TempY)
            
            'Draw tiles
            For b = 0 To Camera.TilesY
                For A = 0 To Camera.TilesX
                    'Floor layer
                    Temp = .Floor(Index)
                    If Temp > 0 Then
'                        BitBlt Camera.BackDC, (A - TempX) * TileW, (b - TempY) * TileH, TileW, TileH, Bitmap(Tile(Temp).Bitmap).Mask, Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW), Tile(Temp).y, vbSrcPaint
'                        BitBlt Camera.BackDC, (A - TempX) * TileW, (b - TempY) * TileH, TileW, TileH, Bitmap(Tile(Temp).Bitmap).DC, Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW), Tile(Temp).y, vbSrcAnd
                        BltToBuffer Tile(Temp).Bitmap, CSng((A - TempX) * TileW), CSng((b - TempY) * TileH), CSng(TileW), CSng(TileH), CSng(Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW)), CSng(Tile(Temp).y), CSng(TileW), CSng(TileH), D3DColorRGBA(255, 255, 255, 255), 0
                    End If
                    
                    Temp = .Object(Index)
                    If Not InGameEdit Then
                        'Editor
                        If Temp > 0 Then
                            BltToBuffer SrcObject(Temp).Bitmap, CSng((A - TempX) * TileW), CSng((b - TempY) * TileH), CSng(SrcObject(Temp).W), CSng(SrcObject(Temp).H), CSng(Tile(Temp).x + (Tile(Temp).Animation.ActX * TileW)), CSng(Tile(Temp).y), CSng(SrcObject(Temp).W), CSng(SrcObject(Temp).H)
                            'BitBlt Camera.BackDC, (A - TempX) * TileW, (b - TempY) * TileH, SrcObject(Temp).W, SrcObject(Temp).H, Bitmap(SrcObject(Temp).Bitmap).DC, 0, 0, vbSrcInvert
                        End If
                        
                    Else
                        If Temp > 0 Then
                            Obj = CreateObject(Temp)
                            
                            With Object(Obj)
                                .x = Camera.x + (A - TempX) * TileW + (.W / 2)
                                .y = Camera.y + (b - TempY) * TileH + .H
                                
                                .SpeedX = IIf(Object(0).x < .x, -1, 1) * .Speed
                            End With
                            
                            .Object(Index) = -.Object(Index)
                        End If
                    End If
        
                    Index = Index + 1
                Next
                
                Index = Index + .W - Camera.TilesX - 1
            Next
        End If
    End With
    
    BltBuffers
    
    'Disable masking
    Device.SetRenderState D3DRS_ALPHATESTENABLE, 0
End Sub
Sub Reset()
    With Level
        ReDim .Sky(0)
        ReDim .Back(0)
        ReDim .Floor(0)
        ReDim .Object(0)
    End With
End Sub

Sub ShutDown()
    Reset
End Sub

