Attribute VB_Name = "mPlayer"
Option Explicit

'Consts
    'MoveMode
    Global Const cWalk As Long = 0
    Global Const cRun As Long = 2
    Global Const cBrake As Long = 4
    Global Const cJump As Long = 5 + 1
    Global Const cDuck As Long = 8
    
'Types
    Type tPlayer
        Bitmap As Long
        Animation As tAnimation
        
        x As Single
        y As Single
        
        w As Long
        h As Long
        
        Dest As Long
        
        SpeedX As Single
        SpeedY As Single
        
        MoveMode As Long
    End Type

'Variables
    Global Player As tPlayer
Sub Clip()
    If Player.x < Player.w Then: Player.x = Player.w
    If Player.y < Player.h Then: Player.y = Player.h
    
    If Player.x + Player.w > (Level.w * TileW) Then: Player.x = Level.w * TileW - Player.w
    If Player.y + Player.h > (Level.h * TileH) Then: Player.y = Level.h * TileH - Player.h 'Active = False
End Sub

Sub Draw()
    BitBlt Camera.BackDC, Int(Player.x - Camera.x - (Player.w / 2)), Int(Player.y - Camera.y - Player.h), Player.w, Player.h, Bitmap(Player.Bitmap).Mask, (Player.Animation.ActX * Player.w), ((Player.MoveMode + Player.Dest) * Player.h), vbSrcPaint
    BitBlt Camera.BackDC, Int(Player.x - Camera.x - (Player.w / 2)), Int(Player.y - Camera.y - Player.h), Player.w, Player.h, Bitmap(Player.Bitmap).DC, (Player.Animation.ActX * Player.w), ((Player.MoveMode + Player.Dest) * Player.h), vbSrcAnd
End Sub
Sub Initialize()
    'Size
    Player.w = 16
    Player.h = 16
    
    Player.Animation.MaxX = 1
End Sub


Sub Reset()
    Player.x = 0
    Player.y = 0
    Clip
End Sub
Sub ShutDown()

End Sub


Sub UpdatePosition()
    If Player.SpeedY >= 0 Then
        'Check position
        If Tile(Level.Floor(Int((Player.y + Player.SpeedY) / TileH) * Level.w + Int(Player.x / TileW))).CollisionMode And cCollideTop Then
            'Stop falling
            Player.SpeedY = 0
            If Player.MoveMode = cJump Then: Player.MoveMode = cWalk
            
            'Walking
            If Tile(Level.Floor(Int((Player.y + Player.SpeedY - 1) / TileH) * Level.w + Int((Player.x + IIf(Player.Dest = 0, 1, -1) * (Player.w / 3)) / TileW))).CollisionMode And cCollideSides Then
                'Collides
                Player.SpeedX = 0
                Player.Animation.Speed = 150
            Else
                'Animation speed
                Player.Animation.Speed = Abs(Player.SpeedX) * 50
            End If

        Else
            'Gravity
            Player.SpeedY = Player.SpeedY + 0.1
            If Player.SpeedY > 2 Then: Player.SpeedY = 2
            
            'Fall movement
            If (Tile(Level.Floor(Int((Player.y + Player.SpeedY - 1) / TileH) * Level.w + Int((Player.x + IIf(Player.Dest = 0, 1, -1) * (Player.w / 3)) / TileW))).CollisionMode And cCollideSides) Then
                'Collides
                Player.SpeedX = 0
            End If
            
            'Jump mode
            Player.MoveMode = cJump
        End If
        
    Else
        'Check position
        If Tile(Level.Floor(Int((Player.y + Player.SpeedY - Player.h + 4) / TileH) * Level.w + Int((Player.x + IIf(Player.Dest = 0, 1, -1) * (Player.w / 3)) / TileW))).CollisionMode And cCollideBottom Then
            'Stop jumping
            Player.SpeedY = 0
            If Player.MoveMode = cJump Then: Player.MoveMode = cWalk
            
            'Walking
            If Tile(Level.Floor(Int((Player.y + Player.SpeedY - 1) / TileH) * Level.w + Int((Player.x + IIf(Player.Dest = 0, 1, -1) * (Player.w / 3)) / TileW))).CollisionMode And cCollideSides Then
                'Collides
                Player.SpeedX = 0
                Player.Animation.Speed = 150
            Else
                'Animation speed
                Player.Animation.Speed = Abs(Player.SpeedX) * 50
            End If

        Else
            'Gravity
            Player.SpeedY = Player.SpeedY + 0.1
            If Player.SpeedY > 2 Then: Player.SpeedY = 2
            
            'Jump movement
            If (Tile(Level.Floor(Int((Player.y + Player.SpeedY - 1) / TileH) * Level.w + Int((Player.x + IIf(Player.Dest = 0, 1, -1) * (Player.w / 3)) / TileW))).CollisionMode And cCollideSides) Then
                'Collides
                Player.SpeedX = 0
            End If
            
            'Jump mode
            Player.MoveMode = cJump
        End If
    End If
    
    'Move player
    Player.x = Player.x + Player.SpeedX
    Player.y = Player.y + Player.SpeedY
    mPlayer.Clip
    
    'Move camera
    If Player.x > Camera.x + Camera.w - (TileW * 5) Then: Camera.x = Player.x - Camera.w + (TileW * 5)
    If Player.x < Camera.x + (TileW * 5) Then: Camera.x = Player.x - (TileW * 5)
    If Player.y > Camera.y + Camera.h - (TileH * 2) Then: Camera.y = Player.y - Camera.h + (TileH * 2)
    If Player.y < Camera.y + (TileH * 3) Then: Camera.y = Player.y - (TileH * 3)
    mCamera.Clip
End Sub
