Attribute VB_Name = "mTiles"
Option Explicit

'Consts
    'CollisionMode
    Global Const cCollide As Long = 0
    Global Const cCollideTop As Long = 1
    Global Const cCollideSides As Long = 2
    Global Const cCollideBottom As Long = 4
    Global Const cPressedDown As Long = 8

'Types
    Type tTile
        BitmapFile As String
        Bitmap As Long
        
        Animation As tAnimation
        
        x As Long
        y As Long
        z As Long
        
        CollisionMode As Long
        
        Action As Long
        Flags As String
    End Type

'Variables
    Global TileW As Long
    Global TileH As Long

    Global TileCount As Long
    Global Tile() As tTile
Sub AnimateTiles()
    Dim A As Long
    
    For A = 0 To TileCount
        Animate Tile(A).Animation
    Next
End Sub
Function CreateTile() As Long
    'Resize memory
    TileCount = TileCount + 1
    ReDim Preserve Tile(TileCount)
    
    'Return index
    CreateTile = TileCount
End Function


Sub LoadTiles()
    Dim A As Long
    
    For A = 1 To TileCount
        With Tile(A)
            'Load bitmap
            .Bitmap = LoadTexture(GraphicPath & .BitmapFile)
            
            'Activate animation
            .Animation.LastTick = 0
            .Animation.Enabled = (.Animation.MaxX > 0)
        End With
    Next
End Sub
Sub Reset()
    TileCount = 0
    ReDim Tile(0)
End Sub

Sub ShutDown()
    Reset
End Sub
Sub SwapTiles(Index1 As Long, Index2 As Long)
    Dim A As Long
    Dim Temp As tTile
    
    'Swap
    Temp = Tile(Index1)
    Tile(Index1) = Tile(Index2)
    Tile(Index2) = Temp
    
    'Update maps
    For A = 0 To (Level.W * Level.H)
        If Level.Back(A) = Index1 Then
            Level.Back(A) = Index2
        ElseIf Level.Back(A) = Index2 Then
            Level.Back(A) = Index1
        End If
        
        If Level.Floor(A) = Index1 Then
            Level.Floor(A) = Index2
        ElseIf Level.Floor(A) = Index2 Then
            Level.Floor(A) = Index1
        End If
        
        If Level.Sky(A) = Index1 Then
            Level.Sky(A) = Index2
        ElseIf Level.Sky(A) = Index2 Then
            Level.Sky(A) = Index1
        End If
    Next
End Sub


